import hudson.model.*
import jenkins.model.*
import hudson.slaves.*
import hudson.plugins.sshslaves.verifiers.NonVerifyingKeyVerificationStrategy
import hudson.slaves.EnvironmentVariablesNodeProperty.Entry

ComputerLauncher launcher = new hudson.plugins.sshslaves.SSHLauncher(
        "{{ item.host }}", 
        22,
        "b3-bitbucket",
         "-Xmx{{ heap_size }}",
         (String)null,
         (String)null,
         (String)null,
         (Integer)null,
         (Integer)null,
         (Integer)null,
         new NonVerifyingKeyVerificationStrategy()
)

Slave agent = new DumbSlave(
        "{{ item.label }}",
        "/apps/jenkins",
        launcher)
agent.nodeDescription = "{{ item.description }}"
agent.numExecutors = 1
agent.labelString = "{{ item.label }}"
agent.mode = Node.Mode.EXCLUSIVE 
agent.retentionStrategy = new RetentionStrategy.Always()

List<Entry> env = new ArrayList<Entry>();
env.add(new Entry("http_proxy","{{ lookup('env','http_proxy') }}" ))
env.add(new Entry("https_proxy","{{ lookup('env','https_proxy') }}" ))
env.add(new Entry("no_proxy","{{ lookup('env','no_proxy') }}" ))
env.add(new Entry("KEYSTORE_PASSWORD","{{ lookup('env','KEYSTORE_PASSWORD') }}" ))
env.add(new Entry("B3CARaiz", "{{ lookup('env','B3CARaiz') }}" ))
env.add(new Entry("B3CASubordinada", "{{ lookup('env','B3CASubordinada') }}" ))
EnvironmentVariablesNodeProperty envPro = new EnvironmentVariablesNodeProperty(env);

agent.getNodeProperties().add(envPro)

// Create a "Permanent Agent"
Jenkins.instance.addNode(agent)

return "Node has been created successfully."
